class Discounts
  
  def initialize(percentage_1, percentage_2, percentage_3)
    @tier_1 = percentage_1
    @tier_2 = percentage_2
    @tier_3 = percentage_3
  end
  
  # Make this dynamic, allow users to pass in as many
  # discount percentages as they want.  Increment by one.
  DISCOUNTS = {
    'pretty_discounts' => {
      'Tier 1' => @tier_1,
      'Tier 2' => @tier_2,
      'Tier 3' => @tier_3
    },
    
    'tier_1' => @tier_1,
    'tier_2' => @tier_2,
    'tier_3' => @tier_3
  }

  # Instance based query method.
  def all 
    DISCOUNTS.values.flatten.uniq
  end
  
  # Helper for select methods in the HTML.  
  # Should you want a dropdown to choose discount type.
  def select_helper
    DISCOUNTS['pretty_discounts']
  end

end


# Interface:
# Somewhere in their application code they call:
# perhaps on the purchase model or the controller for the show view that is 
# responsible for making a purchase.
#
# @discounts = Discounts.new(percentage_1, percentage_2, percentage_3)
# 
# Then via our gem magically they have access to the following
# @discounts.all
# or 
# <%= select_tag 'Choose a discount to apply', @discounts.select_helper' %>
#
# 
